Bug 220308 - !!WARNING!! Missing READ-LOCK when accessing TokenHierarchy
!!WARNING!! Missing READ-LOCK when accessing TokenHierarchy
Status: REOPENED
Product: cnd
Classification: Unclassified
Component: Editor
7.3
All All
: P3 (vote)
: 7.3
Assigned To: Vladimir Voskresensky
issues@cnd
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2012-10-17 16:05 UTC by Vladimir Voskresensky
Modified: 2015-02-03 16:37 UTC (History)
0 users

See Also:
Issue Type: DEFECT
:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Vladimir Voskresensky 2012-10-17 16:05:17 UTC
INFO [org.netbeans.spi.lexer.MutableTextInput]: !!WARNING!! Missing READ-LOCK when accessing TokenHierarchy: input-source:org.netbeans.modules.editor.NbEditorDocument@e5a2ac, mimeType='text/x-h', kitClass=null, length=20008, version=1, file=org.netbeans.modules.cnd.source.HDataObject@1b33228[/export/files/sources/mozilla-2.0/accessible/src/base/nsAccessible.h@35d26ed3:18716cc]
java.lang.Exception
        at org.netbeans.lib.lexer.TokenHierarchyOperation.ensureReadLocked(TokenHierarchyOperation.java:397)
        at org.netbeans.lib.lexer.TokenHierarchyOperation.tokenSequence(TokenHierarchyOperation.java:422)
        at org.netbeans.lib.lexer.TokenHierarchyOperation.tokenSequence(TokenHierarchyOperation.java:418)
        at org.netbeans.api.lexer.TokenHierarchy.tokenSequence(TokenHierarchy.java:186)
        at org.netbeans.api.lexer.TokenHierarchy.embeddedTokenSequences(TokenHierarchy.java:265)
        at org.netbeans.cnd.api.lexer.CndLexerUtilities.getCppTokenSequence(CndLexerUtilities.java:137)
        at org.netbeans.cnd.api.lexer.CndLexerUtilities.getCppTokenSequence(CndLexerUtilities.java:94)
        at org.netbeans.modules.cnd.completion.cplusplus.CsmCodeTemplateFilter.getID(CsmCodeTemplateFilter.java:80)
        at org.netbeans.modules.cnd.completion.cplusplus.CsmCodeTemplateFilter.<init>(CsmCodeTemplateFilter.java:71)
        at org.netbeans.modules.cnd.completion.cplusplus.CsmCodeTemplateFilter.<init>(CsmCodeTemplateFilter.java:57)
        at org.netbeans.modules.cnd.completion.cplusplus.CsmCodeTemplateFilter$Factory.createFilter(CsmCodeTemplateFilter.java:112)
        at org.netbeans.lib.editor.codetemplates.CodeTemplateManagerOperation.getTemplateFilters(CodeTemplateManagerOperation.java:230)
        at org.netbeans.lib.editor.codetemplates.SurroundWithFix.getFixes(SurroundWithFix.java:74)
        at org.netbeans.lib.editor.codetemplates.AbbrevDetection$2.run(AbbrevDetection.java:434)
        at org.openide.util.RequestProcessor$Task.run(RequestProcessor.java:1454)
        at org.openide.util.RequestProcessor$Processor.run(RequestProcessor.java:2036)
Comment 1 markiewb 2012-10-18 15:19:17 UTC
A similar error has already been fixed. Maybe you can adopt the solution?
Have a look at http://netbeans.org/bugzilla/show_bug.cgi?id=220312#c1
Comment 2 Vladimir Voskresensky 2012-10-22 11:13:15 UTC
http://hg.netbeans.org/cnd-main/rev/4f31f1e6c744
Comment 3 Quality Engineering 2012-10-23 12:06:04 UTC
Integrated into 'main-golden', will be available in build *201210231040* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
Changeset: http://hg.netbeans.org/main-golden/rev/4f31f1e6c744
User: Vladimir Voskresensky <vv159170@netbeans.org>
Log: fixed  #220308 - !!WARNING!! Missing READ-LOCK when accessing TokenHierarchy
- use TS under document's read lock
Comment 4 petrk 2015-02-03 16:37:05 UTC
INFO [org.netbeans.spi.lexer.MutableTextInput]: !!WARNING!! Missing READ-LOCK when accessing TokenHierarchy: input-source:org.netbeans.modules.editor.NbEditorDocument@7df82fc1, mimeType='text/x-c++', kitClass=null, length=37, version=27, file=org.netbeans.modules.cnd.source.CCDataObject@60535905[/home/petrk/NetBeansProjects/CppApplication_46/main.cpp@9b0eb351:3f28af0b]
java.lang.Exception
	at org.netbeans.lib.lexer.TokenHierarchyOperation.ensureReadLocked(TokenHierarchyOperation.java:406)
	at org.netbeans.lib.lexer.TokenHierarchyOperation.tokenSequence(TokenHierarchyOperation.java:431)
	at org.netbeans.lib.lexer.TokenHierarchyOperation.tokenSequence(TokenHierarchyOperation.java:427)
	at org.netbeans.lib.lexer.TokenHierarchyOperation.embeddedTokenSequences(TokenHierarchyOperation.java:459)
	at org.netbeans.api.lexer.TokenHierarchy.embeddedTokenSequences(TokenHierarchy.java:265)
	at org.netbeans.cnd.api.lexer.CndLexerUtilities.getCppTokenSequence(CndLexerUtilities.java:137)
	at org.netbeans.cnd.api.lexer.CndLexerUtilities.getCppTokenSequence(CndLexerUtilities.java:94)
	at org.netbeans.modules.cnd.completion.cplusplus.ext.CsmResultItem.isForwardDeclaration(CsmResultItem.java:426)
	at org.netbeans.modules.cnd.completion.cplusplus.ext.CsmResultItem.defaultAction(CsmResultItem.java:374)
	at org.netbeans.modules.cnd.completion.cplusplus.ext.CsmResultItem.defaultAction(CsmResultItem.java:354)
	at org.netbeans.modules.editor.completion.CompletionImpl.dispatchKeyEvent(CompletionImpl.java:676)
	at org.netbeans.modules.editor.completion.CompletionImpl.keyPressed(CompletionImpl.java:404)
	at java.awt.AWTEventMulticaster.keyPressed(AWTEventMulticaster.java:250)
	at java.awt.Component.processKeyEvent(Component.java:6463)
	at javax.swing.JComponent.processKeyEvent(JComponent.java:2828)
	at java.awt.Component.processEvent(Component.java:6282)
	at java.awt.Container.processEvent(Container.java:2229)
	at java.awt.Component.dispatchEventImpl(Component.java:4861)
	at java.awt.Container.dispatchEventImpl(Container.java:2287)
	at java.awt.Component.dispatchEvent(Component.java:4687)
	at java.awt.KeyboardFocusManager.redispatchEvent(KeyboardFocusManager.java:1895)
	at java.awt.DefaultKeyboardFocusManager.dispatchKeyEvent(DefaultKeyboardFocusManager.java:762)
	at java.awt.DefaultKeyboardFocusManager.preDispatchKeyEvent(DefaultKeyboardFocusManager.java:1027)
	at java.awt.DefaultKeyboardFocusManager.typeAheadAssertions(DefaultKeyboardFocusManager.java:899)
	at java.awt.DefaultKeyboardFocusManager.dispatchEvent(DefaultKeyboardFocusManager.java:727)
	at java.awt.Component.dispatchEventImpl(Component.java:4731)
	at java.awt.Container.dispatchEventImpl(Container.java:2287)
	at java.awt.Window.dispatchEventImpl(Window.java:2719)
	at java.awt.Component.dispatchEvent(Component.java:4687)
	at java.awt.EventQueue.dispatchEventImpl(EventQueue.java:735)
	at java.awt.EventQueue.access$200(EventQueue.java:103)
	at java.awt.EventQueue$3.run(EventQueue.java:694)
	at java.awt.EventQueue$3.run(EventQueue.java:692)
	at java.security.AccessController.doPrivileged(Native Method)
	at java.security.ProtectionDomain$1.doIntersectionPrivilege(ProtectionDomain.java:76)
	at java.security.ProtectionDomain$1.doIntersectionPrivilege(ProtectionDomain.java:87)
	at java.awt.EventQueue$4.run(EventQueue.java:708)
	at java.awt.EventQueue$4.run(EventQueue.java:706)
	at java.security.AccessController.doPrivileged(Native Method)
	at java.security.ProtectionDomain$1.doIntersectionPrivilege(ProtectionDomain.java:76)
	at java.awt.EventQueue.dispatchEvent(EventQueue.java:705)
	at org.netbeans.core.TimableEventQueue.dispatchEvent(TimableEventQueue.java:159)
	at java.awt.EventDispatchThread.pumpOneEventForFilters(EventDispatchThread.java:242)
	at java.awt.EventDispatchThread.pumpEventsForFilter(EventDispatchThread.java:161)
	at java.awt.EventDispatchThread.pumpEventsForHierarchy(EventDispatchThread.java:150)
	at java.awt.EventDispatchThread.pumpEvents(EventDispatchThread.java:146)
	at java.awt.EventDispatchThread.pumpEvents(EventDispatchThread.java:138)
	at java.awt.EventDispatchThread.run(EventDispatchThread.java:91)


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2014, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo